MaxCardinalitySearch< GR, CAP, TR >::SetCapacityMap< T > Struct Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members
MaxCardinalitySearch< GR, CAP, TR >::SetCapacityMap< T > Struct Template Reference

## Detailed Description

### template<typename GR, typename CAP, typename TR>
template<class T>
struct lemon::MaxCardinalitySearch< GR, CAP, TR >::SetCapacityMap< T >

Named parameter for setting CapacityMap type for the algorithm.

`#include <lemon/max_cardinality_search.h>`

Inheritance diagram for MaxCardinalitySearch< GR, CAP, TR >::SetCapacityMap< T >:
[legend]

## Additional Inherited Members
Public Types inherited from MaxCardinalitySearch< Digraph, CapacityMap, DefCapacityMapTraits< T > >
typedef Traits::Digraph | Digraph
| The type of the underlying digraph.
typedef Traits::CapacityMap::Value | Value
| The type of the capacity of the arcs.
typedef Traits::CapacityMap | CapacityMap
| The type of the map that stores the arc capacities.
typedef Traits::ProcessedMap | ProcessedMap
| The type of the map indicating if a node is processed.
typedef Traits::CardinalityMap | CardinalityMap
| The type of the map that stores the cardinalities of the nodes.
typedef Traits::HeapCrossRef | HeapCrossRef
| The cross reference type used for the current heap.
typedef Traits::Heap | Heap
| The heap type used by the algorithm. It maximizes the priorities.
Public Member Functions inherited from MaxCardinalitySearch< Digraph, CapacityMap, DefCapacityMapTraits< T > >
| MaxCardinalitySearch (const Digraph &digraph, const CapacityMap &capacity)
| Constructor. More...
| MaxCardinalitySearch (const Digraph &digraph)
| Constructor. More...
| ~MaxCardinalitySearch ()
| Destructor.
MaxCardinalitySearch & | capacityMap (const CapacityMap &m)
| Sets the capacity map. More...
const CapacityMap & | capacityMap () const
| Returns a const reference to the capacity map. More...
MaxCardinalitySearch & | cardinalityMap (CardinalityMap &m)
| Sets the map storing the cardinalities calculated by the algorithm. More...
MaxCardinalitySearch & | processedMap (ProcessedMap &m)
| Sets the map storing the processed nodes. More...
const ProcessedMap & | processedMap () const
| Returns a const reference to the cardinality map. More...
MaxCardinalitySearch & | heap (Heap &hp, HeapCrossRef &cr)
| Sets the heap and the cross reference used by algorithm. More...
const Heap & | heap () const
| Returns a const reference to the heap. More...
const HeapCrossRef & | heapCrossRef () const
| Returns a const reference to the cross reference. More...
const CardinalityMap & | cardinalityMap () const
| Returns a reference to the NodeMap of cardinalities. More...
Value | cardinality (Node node) const
| The cardinality of a node. More...
Value | currentCardinality (Node node) const
| The current cardinality of a node. More...
bool | reached (Node v)
| Checks if a node is reachable from the root. More...
bool | processed (Node v)
| Checks if a node is processed. More...
void | init ()
| Initializes the internal data structures. More...
void | addSource (Node source, Value capacity=0)
| Adds a new source node. More...
Node | processNextNode ()
| Processes the next node in the priority heap. More...
Node | nextNode ()
| Next node to be processed. More...
bool | emptyQueue ()
| Returns `false` if there are nodes to be processed in the priority heap. More...
int | emptySize ()
| Returns the number of the nodes to be processed in the priority heap. More...
void | start ()
| Executes the algorithm. More...
void | start (Node dest)
| Executes the algorithm until `dest` is reached. More...
void | start (const NodeBoolMap &nm)
| Executes the algorithm until a condition is met. More...
void | run (Node s)
| Runs the maximum cardinality search algorithm from node `s`. More...
void | run ()
| Runs the maximum cardinality search algorithm for the whole digraph. More...